<?php

namespace TypechoPlugin\VidoeShowFree;

use Typecho\Plugin\PluginInterface;
use Typecho\Widget\Helper\Form;
use Typecho\Widget\Helper\Form\Element\Text;
use Widget\Options;

if (!defined('__TYPECHO_ROOT_DIR__')) {
    exit;
}

/**
 * 秀视频免费版，通过短代码的方式便捷的插入视频播放器，支持调用各大影视平台iframe播放器，要求Typecho1.2.0版本及以上
 *
 * @package VidoeShowFree
 * @author 泽泽社长
 * @version 0.2.0
 * @link https://store.typecho.work/archives/vidoeshow-typecho-platform.html
 */
class Plugin implements PluginInterface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     */
    public static function activate()
    {
        \Typecho\Plugin::factory('Widget_Archive')->header_11 = __CLASS__ . '::headercss';
        \Typecho\Plugin::factory('Widget_Abstract_Contents')->contentEx_11 = __CLASS__ . '::render';
    }

    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     */
    public static function deactivate()
    {
    }

    /**
     * 获取插件配置面板
     *
     * @param Form $form 配置面板
     */
    public static function config(Form $form)
    {
    }

    /**
     * 个人用户的配置面板
     *
     * @param Form $form
     */
    public static function personalConfig(Form $form)
    {
    }

    /**
     * 插件实现方法
     *
     * @access public
     * @return void
     */
    public static function render($con,$obj,$text)
    {
    /*固定写法*/
    $text = empty($text)?$con:$text;
    $text = preg_replace_callback('#(<p>)?\{video( title="(.*?)")?\}(<br\s*/?>)?([\s\S]*?)(<br\s*/?>)?\{\/video\}(<\/p>)?#',[__CLASS__, 'video'],$text);
    return $text;
    }
    public static function video($m){
    $title=false;
    if(!empty($m[3])){$title=$m[3];}
    $url=preg_replace('/<a(.*?)>(.*?)<\/a>/i', '$2', $m[5]);
    
    if(strpos($url,'www.bilibili.com/video') !== false){//调用哔哩哔哩iframe
    $bv=preg_replace('/(.*?)www.bilibili.com\/video\/(.*?)(\/)?/i', '$2', $url);
    $bv=str_ireplace('/', '', $bv);
    $url='https://www.bilibili.com/blackboard/html5mobileplayer.html?bvid='.$bv.'&page=1&fjw=0&danmaku=0';
    }elseif(strpos($url,'www.acfun.cn/v/') !== false){
    $ac=preg_replace('/(.*?)www.acfun.cn\/v\/(.*?)(\/)?/i', '$2', $url);
    $url='//www.acfun.cn/player/'.$ac;
    }elseif(strpos($url,'www.ixigua.com/') !== false){
    $xg=preg_replace('/(.*?)www.ixigua.com\/(.*?)(\?)?/i', '$2', $url);
    $url='//www.ixigua.com/iframe/'.$xg.'?autoplay=0';
    }
    else{
    $url=$url;
    }
     
     
     $video=$url;
     
     
    $player='<div class="zezemedia zezemedia-16x9"><iframe src="'.$video.'" scrolling="no" border="0" frameborder="no" framespacing="0" allowfullscreen="true"></iframe></div>';
    return $player;
        
    }
    public static function headercss(){
    $cssUrl = Options::alloc()->pluginUrl . '/VidoeShowFree/style.css?2023';
    echo '<link rel="stylesheet" href="' . $cssUrl . '">';
    }
}